class HashMap {
  
  class Entry {
    Object key;
    Object value; 
    boolean isDeleted;
    Entry(Object key, Object value) {
      this.key = key;
      this.value = value;
    }
  }

  Entry[] tab;
  
  HashMap(int tabSize) {
    tab = new Entry[tabSize];
  }

  Object get(Object key) {
    int a = hash(key), a0 = 0;
    while (tab[a] != null && (tab[a].isDeleted || !tab[a].key.equals(key))) {
      a = (a + 1) % tab.length;
      if (a0 == a) {
        return null;
      }
    }
    if (tab[a] != null) {
      return tab[a].value;
    } else {
      return null;
    }
  }
  
  void put(Object key, Object value) {
    int a = hash(key), a0 = a;
    while (tab[a] != null && (tab[a].isDeleted || !tab[a].key.equals(key))) {
      a = (a + 1) % tab.length;
      if (a0 == a) {
        throw new IllegalStateException();
      }
    }
    tab[a] = new Entry(key, value);
  }
  
  int hash(Object key) {
    return Math.abs(key.hashCode()) % tab.length;
  }
  
  Object remove(Object key) {
    int a = hash(key), a0 = a;
    while (tab[a] != null && (tab[a].isDeleted || !tab[a].key.equals(key))) {
      a = (a + 1) % tab.length;
      if (a0 == a) {
        return null;
      }
    }
    if (tab[a] != null) {
      tab[a].isDeleted = true;
      return tab[a].value;
    } else {
      return null;
    }
  }
  
  void makeDot(String filename) {
    Out.open(filename);
    Out.print(DotMakerHashtable.makeDot(this));
    Out.close();
  }
}